home *** CD-ROM | disk | FTP | other *** search
/ Skunkware 5 / Skunkware 5.iso / lib / install-tools / fixincludes < prev    next >
Text File  |  1995-07-12  |  9KB  |  315 lines

  1. #! /bin/sh
  2. #
  3. #   fixinc.sco  --  Install modified versions of SCO system include
  4. #   files.
  5. #
  6. #   Based on fixinc.svr4 script by Ron Guilmette (rfg@ncd.com) (SCO
  7. #   modifications by Ian Lance Taylor (ian@airs.com)).
  8. #
  9. # This file is part of GNU CC.
  10. # GNU CC is free software; you can redistribute it and/or modify
  11. # it under the terms of the GNU General Public License as published by
  12. # the Free Software Foundation; either version 2, or (at your option)
  13. # any later version.
  14. # GNU CC is distributed in the hope that it will be useful,
  15. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  16. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  17. # GNU General Public License for more details.
  18. # You should have received a copy of the GNU General Public License
  19. # along with GNU CC; see the file COPYING.  If not, write to
  20. # the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
  21. #
  22. #    This script munges the native include files provided with SCO
  23. #    3.2v4 systems so as to provide a reasonable namespace when
  24. #    compiling with gcc.  The header files by default do not
  25. #    provide many essential definitions and declarations if
  26. #    __STDC__ is 1.  This script modifies the header files to check
  27. #    for __STRICT_ANSI__ being defined instead.  Once munged, the
  28. #    resulting new system include files are placed in a directory
  29. #    that GNU C will search *before* searching the /usr/include
  30. #    directory.  This script should work properly for most SCO
  31. #    3.2v4 systems.  For other types of systems, you should use the
  32. #    `fixincludes' or the `fixinc.svr4' script instead.
  33. #
  34. #    See README-fixinc for more information.
  35.  
  36. # Directory containing the original header files.
  37. INPUT=${2-${INPUT-/usr/include}}
  38.  
  39. # Fail if no arg to specify a directory for the output.
  40. if [ x$1 = x ]
  41. then echo fixincludes: no output directory specified
  42. exit 1
  43. fi
  44.  
  45. # Directory in which to store the results.
  46. LIB=${1?"fixincludes: output directory not specified"}
  47.  
  48. # Make sure it exists.
  49. if [ ! -d $LIB ]; then
  50.   mkdir $LIB || exit 1
  51. fi
  52.  
  53. ORIG_DIR=`pwd`
  54.  
  55. # Make LIB absolute if it is relative.
  56. # Don't do this if not necessary, since may screw up automounters.
  57. case $LIB in
  58. /*)
  59.     ;;
  60. *)
  61.     cd $LIB; LIB=`${PWDCMD-pwd}`
  62.     ;;
  63. esac
  64.  
  65. echo 'Building fixincludes in ' ${LIB}
  66.  
  67. # Determine whether this filesystem has symbolic links.
  68. if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
  69.   rm -f $LIB/ShouldNotExist
  70.   LINKS=true
  71. else
  72.   LINKS=false
  73. fi
  74.  
  75. echo 'Making directories:'
  76. cd ${INPUT}
  77. if $LINKS; then
  78.   files=`ls -LR | sed -n s/:$//p`
  79. else
  80.   files=`find . -type d -print | sed '/^.$/d'`
  81. fi
  82. for file in $files; do
  83.   rm -rf $LIB/$file
  84.   if [ ! -d $LIB/$file ]
  85.   then mkdir $LIB/$file
  86.   fi
  87. done
  88.  
  89. # treetops gets an alternating list
  90. # of old directories to copy
  91. # and the new directories to copy to.
  92. treetops="${INPUT} ${LIB}"
  93.  
  94. if $LINKS; then
  95.   echo 'Making internal symbolic directory links'
  96.   for file in $files; do
  97.     dest=`ls -ld $file | sed -n 's/.*-> //p'`
  98.     if [ "$dest" ]; then    
  99.       cwd=`pwd`
  100.       # In case $dest is relative, get to $file's dir first.
  101.       cd ${INPUT}
  102.       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
  103.       # Check that the target directory exists.
  104.       # Redirections changed to avoid bug in sh on Ultrix.
  105.       (cd $dest) > /dev/null 2>&1
  106.       if [ $? = 0 ]; then
  107.     cd $dest
  108.     # X gets the dir that the link actually leads to.
  109.     x=`pwd`
  110.     # If link leads back into ${INPUT},
  111.     # make a similar link here.
  112.     if expr $x : "${INPUT}/.*" > /dev/null; then
  113.       # Y gets the actual target dir name, relative to ${INPUT}.
  114.       y=`echo $x | sed -n "s&${INPUT}/&&p"`
  115.       echo $file '->' $y ': Making link'
  116.       rm -fr ${LIB}/$file > /dev/null 2>&1
  117.       ln -s ${LIB}/$y ${LIB}/$file > /dev/null 2>&1
  118.     else
  119.       # If the link is to outside ${INPUT},
  120.       # treat this directory as if it actually contained the files.
  121. # This line used to have $dest instead of $x.
  122. # $dest seemed to be wrong for links found in subdirectories
  123. # of ${INPUT}.  Does this change break anything?
  124.       treetops="$treetops $x ${LIB}/$file"
  125.     fi
  126.       fi
  127.       cd $cwd
  128.     fi
  129.   done
  130. fi
  131.  
  132. set - $treetops
  133. while [ $# != 0 ]; do
  134.   # $1 is an old directory to copy, and $2 is the new directory to copy to.
  135.   echo "Finding header files in $1:"
  136.   cd ${INPUT}
  137.   cd $1
  138.   files=`find . -name '*.h' -type f -print`
  139.   echo 'Checking header files:'
  140.   for file in $files; do
  141.     if egrep '!__STDC__' $file >/dev/null; then
  142.       if [ -r $file ]; then
  143.     cp $file $2/$file >/dev/null 2>&1 || echo "Can't copy $file"
  144.     chmod +w $2/$file
  145.     chmod a+r $2/$file
  146.  
  147. # The following have been removed from the sed command below
  148. # because it is more useful to leave these things in.
  149. # The only reason to remove them was for -pedantic,
  150. # which isn't much of a reason. -- rms.
  151. #      /^[     ]*#[     ]*ident/d
  152.  
  153.     sed -e '
  154.       s/!__STDC__/!defined (__STRICT_ANSI__)/g
  155.     ' $2/$file > $2/$file.sed
  156.     mv $2/$file.sed $2/$file
  157.     if cmp $file $2/$file >/dev/null 2>&1; then
  158.        rm $2/$file
  159.     else
  160.        echo Fixed $file
  161.     fi
  162.       fi
  163.     fi
  164.   done
  165.   shift; shift
  166. done
  167.  
  168. # Fix first broken decl of getcwd present on some svr4 systems.
  169.  
  170. file=stdlib.h
  171. base=`basename $file`
  172. if [ -r ${LIB}/$file ]; then
  173.   file_to_fix=${LIB}/$file
  174. else
  175.   if [ -r ${INPUT}/$file ]; then
  176.     file_to_fix=${INPUT}/$file
  177.   else
  178.     file_to_fix=""
  179.   fi
  180. fi
  181. if [ \! -z "$file_to_fix" ]; then
  182.   echo Checking $file_to_fix
  183.   sed -e 's/getcwd(char \{0,\}\*, int)/getcwd(char *, size_t)/' $file_to_fix > /tmp/$base
  184.   if cmp $file_to_fix /tmp/$base >/dev/null 2>&1; then \
  185.     true
  186.   else
  187.     echo Fixed $file_to_fix
  188.     rm -f ${LIB}/$file
  189.     cp /tmp/$base ${LIB}/$file
  190.     chmod a+r ${LIB}/$file
  191.   fi
  192.   rm -f /tmp/$base
  193. fi
  194.  
  195. # Fix second broken decl of getcwd present on some svr4 systems.  Also
  196. # fix the incorrect decl of profil present on some svr4 systems.
  197.  
  198. file=unistd.h
  199. base=`basename $file`
  200. if [ -r ${LIB}/$file ]; then
  201.   file_to_fix=${LIB}/$file
  202. else
  203.   if [ -r ${INPUT}/$file ]; then
  204.     file_to_fix=${INPUT}/$file
  205.   else
  206.     file_to_fix=""
  207.   fi
  208. fi
  209. if [ \! -z "$file_to_fix" ]; then
  210.   echo Checking $file_to_fix
  211.   sed -e 's/getcwd(char \*, int)/getcwd(char *, size_t)/' $file_to_fix \
  212.     | sed -e 's/profil(unsigned short \*, unsigned int, unsigned int, unsigned int)/profil(unsigned short *, size_t, int, unsigned)/' > /tmp/$base
  213.   if cmp $file_to_fix /tmp/$base >/dev/null 2>&1; then \
  214.     true
  215.   else
  216.     echo Fixed $file_to_fix
  217.     rm -f ${LIB}/$file
  218.     cp /tmp/$base ${LIB}/$file
  219.     chmod a+r ${LIB}/$file
  220.   fi
  221.   rm -f /tmp/$base
  222. fi
  223.  
  224. # Fix third broken decl of getcwd on SCO.  Also fix incorrect decl of
  225. # link.
  226. file=prototypes.h
  227. base=`basename $file`
  228. if [ -r ${LIB}/$file ]; then
  229.   file_to_fix=${LIB}/$file
  230. else
  231.   if [ -r ${INPUT}/$file ]; then
  232.     file_to_fix=${INPUT}/$file
  233.   else
  234.     file_to_fix=""
  235.   fi
  236. fi
  237. if [ \! -z "$file_to_fix" ]; then
  238.   echo Checking $file_to_fix
  239.   sed -e 's/getcwd(char \*, int)/getcwd(char *, size_t)/' $file_to_fix \
  240.     | sed -e 's/const  int    link(const char \*, char \*)/extern  int    link(const char *, const char *)/' > /tmp/$base
  241.   if cmp $file_to_fix /tmp/$base >/dev/null 2>&1; then \
  242.     true
  243.   else
  244.     echo Fixed $file_to_fix
  245.     rm -f ${LIB}/$file
  246.     cp /tmp/$base ${LIB}/$file
  247.     chmod a+r ${LIB}/$file
  248.   fi
  249.   rm -f /tmp/$base
  250. fi
  251.  
  252. # Fix an error in this file: the #if says _cplusplus, not the double
  253. # underscore __cplusplus that it should be
  254. file=tinfo.h
  255. if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
  256.   mkdir ${LIB}/rpcsvc 2>/dev/null
  257.   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
  258.   chmod +w ${LIB}/$file 2>/dev/null
  259.   chmod a+r ${LIB}/$file 2>/dev/null
  260. fi
  261.  
  262. if [ -r ${LIB}/$file ]; then
  263.   echo Fixing $file, __cplusplus macro
  264.   sed -e 's/[     ]_cplusplus/ __cplusplus/' ${LIB}/$file > ${LIB}/${file}.sed
  265.   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
  266.   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
  267.     rm ${LIB}/$file
  268.   fi
  269. fi
  270.  
  271. # Fix prototype declaration of utime in sys/times.h.  In 3.2v4.0 the
  272. # const is missing.
  273. file=sys/times.h
  274. if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
  275.   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
  276.   chmod +w ${LIB}/$file 2>/dev/null
  277.   chmod a+r ${LIB}/$file 2>/dev/null
  278. fi
  279.  
  280. if [ -r ${LIB}/$file ]; then
  281.   echo Fixing $file, utime prototype
  282.   sed -e 's/(const char \*, struct utimbuf \*);/(const char *, const struct utimbuf *);/' ${LIB}/$file > ${LIB}/${file}.sed
  283.   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
  284.   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
  285.     rm ${LIB}/$file
  286.   fi
  287. fi
  288.  
  289. echo 'Removing unneeded directories:'
  290. cd $LIB
  291. files=`find . -type d -print | sort -r`
  292. for file in $files; do
  293.   rmdir $LIB/$file > /dev/null 2>&1
  294. done
  295.  
  296. if $LINKS; then
  297.   echo 'Making internal symbolic non-directory links'
  298.   cd ${INPUT}
  299.   files=`find . -type l -print`
  300.   for file in $files; do
  301.     dest=`ls -ld $file | sed -n 's/.*-> //p'`
  302.     if expr "$dest" : '[^/].*' > /dev/null; then    
  303.       target=${LIB}/`echo file | sed "s|[^/]*\$|$dest|"`
  304.       if [ -f $target ]; then
  305.         ln -s $dest ${LIB}/$file >/dev/null 2>&1
  306.       fi
  307.     fi
  308.   done
  309. fi
  310.  
  311. exit 0
  312.